package alex.carmessenger;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import javax.crypto.SecretKey;
/*
 * The security class demonstrates the security methods from the SecurityModel class. 
 * The activity displays the encryption method and the decryption method.  
*/

public class security extends AppCompatActivity {
    static final int READ_BLOCK_SIZE = 100;
    TextView txtCipherText;
    TextView txtEncrypted;
    Button encryptBtn;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_security);
        txtCipherText = (TextView)findViewById(R.id.securityDecrypted);
        txtEncrypted =(TextView)findViewById(R.id.securityEncrypted);
        encryptBtn = (Button)findViewById(R.id.securityBtn);
        final EditText plaintext = (EditText) findViewById(R.id.securityEnterPT);

        encryptBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                try{
                    SecretKey key = SecurityModel.generateKey();
                    byte[] newBytes = SecurityModel.encryptMsg(plaintext.getText().toString(), key);
                    String decryptedNewBytes = SecurityModel.decryptMsg(newBytes, key);
                    txtEncrypted.setText(newBytes.toString());
                    txtCipherText.setText(decryptedNewBytes);

                }catch(Exception e){
                    e.printStackTrace();
                }
                }
            }
        );
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_actions, menu);

        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.action_homeButton:
                Intent mainMenuIntent = new Intent(this, MainMenu.class);
                startActivity(mainMenuIntent);
                finish();
                return true;

            case R.id.action_new_message:
                Intent sendMessageIntent = new Intent(this, sendMessage.class);
                startActivity(sendMessageIntent);
                finish();
                return true;

            case R.id.action_logout:
                Intent logoutIntent = new Intent(this, HomeScreen.class);
                startActivity(logoutIntent);
                finish();
                return true;

            default:
                // If we got here, the user's action was not recognized.
                // Invoke the superclass to handle it.
                return super.onOptionsItemSelected(item);

        }
    }



    }

